unit dna;

interface

function analyse(n:longint; t: longint) : ansistring;

implementation

uses graderlib;

function zeroes(m: longint) : ansistring;
var
	res: ansistring;
	i: integer;
begin
	setlength(res, m);
    for i := 1 to m do begin
        res[i] := '0';
    end;
    zeroes := res;
end;


function analyse(n: longint; t: longint) : ansistring;
var
  l, r, m, zeroesCount, maxZeroesCount: longint;
  s: ansistring;
begin
    l := 0; r := n + 1;
    while (l < r - 1) do begin
        m := (l + r) div 2;
        if (make_test(zeroes(m))) then
            l := m
        else
            r := m;
    end;

    s := zeroes(l);
    zeroesCount := 0;
    maxZeroesCount := l;
    while (true) do begin
        s := s + '1';
        if (not make_test(s)) then begin
            s[length(s)] := '0';
            inc(zeroesCount);
        end else begin
            zeroesCount := 0;
        end;
        if (zeroesCount + maxZeroesCount >= n) or (zeroesCount >= maxZeroesCount + 1) then
            break;
    end;
    
    l := 0; r := zeroesCount;
    s := copy(s, 1, length(s) - zeroesCount);

    while (l < r - 1) do begin
        m := (l + r) div 2;
        if (make_test(s + zeroes(m))) then 
            l := m
        else
            r := m;
    end;

    s := s + zeroes(l);

    while (length(s) < n) do begin
        s := '1' + s;
        if (not make_test(s)) then
            s[1] := '0';
    end;

    analyse := s;	
end;

end.