import random
random.seed("something")

class TestGen:
    def __init__(self):
        self.test_number = 0

    def generate_samples(self):
        self.print_test("101", 7)

    def generate_min_tests(self, n, t):
        self.print_test("0", t)
        self.print_test("1", t)
        self.print_test("00", t)
        self.print_test("01", t)
        self.print_test("10", t)
        self.print_test("11", t)
        if n >= 6:
            self.print_test("101111", t)
            self.print_test("111111", t)
            self.print_test("000000", t)
            self.print_test("001000", t)
            self.print_test("000001", t)
                                                              
    def generate_random_test(self, maxn, t):
        n = maxn
        s = ""
        for i in range(n):
            if random.randint(1, 2) == 1:
                s += "0"
            else:
                s += "1"
        self.print_test(s, t)

    def generate_max_tests(self, maxn, t):
        n = maxn
        s = ""
        for i in range(n // 2):
            s += "01"
        self.print_test(s, t)

        n = maxn
        s = ""
        for i in range(n // 2):
            s += "10"
        self.print_test(s, t)

        n = maxn
        s = ""
        for i in range(n):
            s += "0"
        self.print_test(s, t)

        n = maxn
        s = ""
        for i in range(n):
            s += "1"
        self.print_test(s, t)

        n = maxn
        s = "0"
        for i in range(n - 1):
            s += "1"
        self.print_test(s, t)

        n = maxn
        s = "1"
        for i in range(n - 1):
            s += "0"
        self.print_test(s, t)

        for it in range(5):
            n = maxn
            s = ""
            add = random.randint(1, 20) * 2
            if add > n:
                add = n
            for i in range((n - add) // 2):
                s += "10"
            for i in range(add):
                index = random.randint(0, len(s))
                lefts = ""
                rights = ""
                if index > 0:
                    lefts = s[:index]
                if index < len(s):
                    rights = s[index:]
                if random.randint(1, 2) == 1:
                    s = lefts + "0" + rights
                else:
                    s = lefts + "1" + rights
            self.print_test(s, t)

        n = maxn
        s = ""
        for i in range(n // 2):
            s += "0"
        for i in range(n // 2):
            s += "1"
        self.print_test(s, t)
        
        n = maxn
        s = ""
        for i in range(n // 2):
            s += "1"
        for i in range(n // 2):
            s += "0"
        self.print_test(s, t)
        
    def print_test(self, s, t):
        self.test_number += 1
        print("Test", self.test_number)
        test_name = "../tests/" + "{0:0=2d}".format(self.test_number)
        test_file = open(test_name, "w")
        print(s, file=test_file)
        print(t, file=test_file)
        test_file.close()

    def generate_tests(self, n, t):
        self.generate_min_tests(n, t)                          
        smalln = n // 100
        midn = n // 10
        maxn = n
        if smalln > 1:
            for i in range(5):                                
                self.generate_random_test(smalln, t)
        if midn > 1:
            for i in range(5):                                
                self.generate_random_test(midn, t)
        for i in range(5):                                
            self.generate_random_test(maxn, t)
        self.generate_max_tests(maxn, t)                     


    def generate_all_tests(self):
        print("Group 0")
        self.generate_samples()
        print("Group 1")
        self.generate_tests(5, 31)
        print("Group 2")
        self.generate_tests(100, 256)
        print("Group 3")
        self.generate_tests(1000, 1024)


import os, shutil
if os.path.exists('../tests'):
    print('Directory tests is already exists')
    shutil.rmtree('../tests', ignore_errors=False, onerror=None)
try:
    os.makedirs('../tests')
except OSError:
    pass

import time
start = time.time()
writer = TestGen()
writer.generate_all_tests()
finish = time.time()
print('All tests were generated. Elapsed time: ', finish - start)